//引用 store
import store from '@/store/index.js'

let buried_point_host = 'https://zjf.cppc360.com' //埋点请求域名
let domain_H5 = 'https://wap.zjiaf.com' //h5域名   http://test.zjiaf.com
let baseUrl = 'https://zjf.cppc360.com' //正式
// let baseUrl='https://test.cppc360.com'//测试
// let baseUrl = 'http://192.168.1.6:9090'
// let baseUrl = 'http://192.168.1.113:8077' // 谢亮华
// let baseUrl = 'http://192.168.1.10:8989'
// let baseUrl = 'http://192.168.1.6:8989' // 巨量
// let baseUrl = 'http://192.168.1.18:80'
//let baseUrl = 'http://192.168.1.149:40'
// let baseUrl = 'http://192.168.124.8' //帅
// let baseUrl = 'http://192.168.1.132:8090' //胡效求
//let baseUrl = "http://zjftest.com"


// ------------------request方法  start-----------------------
const request = function(route_path, params, callback) {
	let header = {
		'content-type': 'application/json'
	}
	return new Promise((resolve, reject) => {
		uni.request({
			url: buried_point_host + route_path,
			header: header,
			method: 'POST',
			data: params,
			success: res => {
				if (res) {
					resolve(res.data)
				} else {
					reject(res)
				}
			},
			fail: err => {
				console.log('err', err)
				reject(err)
			}
		})
	}).catch((e) => {
		let obj = {
			code: 1000,
			msg: '网络超时',
			data: "网络超时"
		}
		return obj
	})
}
// ------------------request方法  end-----------------------



// ------------------获取日期时间方法  start-----------------------
const getDataTime = function(timeStamp) {
	if (timeStamp) {
		var date = new Date(parseInt(timeStamp) * 1000);
	} else {
		var date = new Date();
	}
	var hengGang = "-";
	var maoHao = ":";
	var month = date.getMonth() + 1;
	var curDate = date.getDate();
	var curHours = date.getHours();
	var curMinutes = date.getMinutes();
	var curSeconds = date.getSeconds();

	if (month >= 1 && month <= 9) {
		month = "0" + month;
	}
	if (curDate >= 0 && curDate <= 9) {
		curDate = "0" + curDate;
	}
	if (curHours >= 0 && curHours <= 9) {
		curHours = "0" + curHours;
	}
	if (curMinutes >= 0 && curMinutes <= 9) {
		curMinutes = "0" + curMinutes;
	}
	if (curSeconds >= 0 && curSeconds <= 9) {
		curSeconds = "0" + curSeconds;
	}

	var currentdate = date.getFullYear() + hengGang + month + hengGang + curDate +
		" " + curHours + maoHao + curMinutes +
		maoHao + curSeconds;
	// var currentdate =
	//   curHours + maoHao + curMinutes + maoHao + curSeconds;
	return currentdate;
}
// ------------------获取日期时间方法  end-----------------------



// ------------------获取页面路由参数  start-----------------------
const getRoutePath = function() {
	try {
		let routes = getCurrentPages(); // 获取当前打开过的页面路由数组
		let curRoute = routes[routes.length - 1].route //获取当前页面路由
		let curParam = routes[routes.length - 1].options; //获取路由参数
		let fullPath = routes[routes.length - 1].$page.fullPath //完整地址
		return {
			route: curRoute,
			params: curParam,
			fullPath: fullPath,
		}
	} catch (e) {
		//TODO handle the exception
	}
}
// ------------------获取页面路由参数  end-----------------------



// ------------------获取Ip start-----------------------
const getIP = async function() {
	try {
		var $result = new Promise((resolve, reject) => {
			uni.request({
				url: 'http://pv.sohu.com/cityjson?ie=utf-8',
				method: 'POST',
				success: res => {
					const reg = /\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}/
					let ip = reg.exec(res.data)
					var IP = ip[0]
					console.log(IP)
					resolve(IP)
				},
				fail: err => {
					console.log('getIP err', err)
				}
			})
		})
		return $result
	} catch (e) {
		//TODO handle the exception
	}
}
// ------------------获取Ip end-----------------------



export default {
	//全局参数
	loadingStart: '加载中...',
	loadingOver: '加载完成',
	loadingFinish: '没有更多数据了',
	loadingError: '服务器开小差了，请稍后再试',
	domain_H5: domain_H5,  //h5域名
	baseUrl: baseUrl,
	buried_point_host: buried_point_host,


	// ------------------埋点方法  start-----------------------

	// 登录登出记录
	logInOutLogs: async (logInOutType) => {
		var userInfo = store.state.userInfo
		let params = {
			"logInOutType": logInOutType,
			"openId": userInfo.open_id,
			"requestDate": getDataTime(),
			"requestIp": userInfo.user_ip_address || await getIP(),
			"userId": userInfo.user_id,
			"userNickName": userInfo.user_name || userInfo.nick_name,
			"userRegisterTime": getDataTime(userInfo.addtime),
			"report_url": '/business-center-app-zjf/api/logInOutLogs/logs'
		}
		return request('/buryingPoint', params)
	},


	// 页面浏览记录
	//provinces 省集合
	//fromType 来自哪个板块：个人版、企业版sda
	pageBrowsingRecord: async (service_code, serviceRemark,fromType,provinces) => {
		var userInfo = store.state.userInfo
		if (userInfo == undefined || userInfo == '') {
			// return false
		}

		var token = store.state.token

		// #ifdef APP
		var sourceType = 'APP'
		// #endif

		// #ifdef H5
		var sourceType = 'H5'
		// #endif

		var routePath = getRoutePath()

		// if (service_code == undefined || service_code == null || service_code == '') {
		// 	service_code = 'NORMAL'
		// }
		// if (serviceRemark == undefined || serviceRemark == null || serviceRemark == '') {
		// 	serviceRemark = routePath.fullPath
		// }

		var userPayType = '免费'
		if (userInfo.user_class > 0) {
			userPayType = '付费'
		}

		//指定的页面
		switch (routePath.route) {
			case 'pages/newSearch/search/search':
				service_code = 'PAGE_BROWSING_RECORD_INDEX'
				serviceRemark = '页面浏览记录-首页'
				break;
			case 'pages/pay/index':
			case 'pages/newPay/newPay':
			case 'pages/pay/qy_pay':
				service_code = 'PAGE_BROWSING_RECORD_PAY'
				serviceRemark = '页面浏览记录-支付页面'
				break;
		}

		let params = {
			"channelType": userInfo.channelType,
			"openId": userInfo.open_id,
			"requestDate": getDataTime(),
			"requestIp": userInfo.user_ip_address || await getIP(),
			"serviceCode": service_code,
			"serviceRemark": serviceRemark,
			"sourceType": sourceType,
			"url": routePath.fullPath,
			"userId": userInfo.user_id || Date.parse(new Date())/1000,
			"userNickName": userInfo.user_name || userInfo.nick_name,
			"userPayType": userPayType,
			"userRegisterTime": getDataTime(userInfo.addtime),
			"userType": userInfo.user_id ? '已注册' : '游客',
			"userType": userInfo.user_id ? '已注册' : '游客',
			"fromType" : fromType||'',
			"provinces" : provinces||[],

			"report_url": '/business-center-app-zjf/api/pageBrowsingRecord/logs'
		}
		return request('/buryingPoint', params)
	},



	// 操作热点记录
	hotsLogs: (service_code, serviceRemark, serviceKey, serviceType, serviceTypeRemark) => {
		var userInfo = store.state.userInfo
		var token = store.state.token

		// #ifdef APP
		var sourceType = 'APP'
		// #endif

		// #ifdef H5
		var sourceType = 'H5'
		// #endif

		var routePath = getRoutePath()

		if (service_code == undefined || service_code == null || service_code == '') {
			service_code = 'NORMAL'
		}
		if (serviceRemark == undefined || serviceRemark == null || serviceRemark == '') {
			serviceRemark = routePath.fullPath
		}

		var userPayType = '免费'
		if (userInfo.user_class > 0) {
			userPayType = '付费'
		}

		let params = {
			"channelType": userInfo.channelType,
			"pagePath": routePath.fullPath,
			"requestDate": getDataTime(),
			"serviceCode": service_code,
			"serviceKey": serviceKey,
			"serviceRemark": serviceRemark,
			"serviceType": serviceType,
			"serviceTypeRemark": serviceTypeRemark,
			"sourceType": sourceType,
			"totalBusinessType": "",
			"userId": userInfo.user_id || Date.parse(new Date())/1000,
			"userPayType": userPayType,
			"userType": userInfo.user_id ? '已注册' : '游客',
			"report_url": '/business-center-app-zjf/api/hotsLogs/logs-oper'
		}
		return request('/buryingPoint', params)
	},



	// 操作热点记录 API订阅设置
	hotsLogsSubscribe: (service_code, serviceRemark, serviceKey, serviceKeyBelonging) => {
		var userInfo = store.state.userInfo
		var token = store.state.token

		// #ifdef APP
		var sourceType = 'APP'
		// #endif

		// #ifdef H5
		var sourceType = 'H5'
		// #endif

		var routePath = getRoutePath()

		if (service_code == undefined || service_code == null || service_code == '') {
			service_code = 'NORMAL'
		}
		if (serviceRemark == undefined || serviceRemark == null || serviceRemark == '') {
			serviceRemark = routePath.fullPath
		}

		var userPayType = '免费'
		if (userInfo.user_class > 0) {
			userPayType = '付费'
		}

		let params = {
			"channelType": userInfo.channelType,
			"pagePath": routePath.fullPath,
			"requestDate": getDataTime(),
			"serviceCode": service_code,
			"serviceKey": serviceKey,
			"serviceKeyBelonging": serviceKeyBelonging,
			"serviceRemark": serviceRemark,
			"serviceType": 'SETTING_SUBSCRIBE',
			"serviceTypeRemark": '订阅设置',
			"sourceType": sourceType,
			"totalBusinessType": "",
			"userId": userInfo.user_id || Date.parse(new Date())/1000,
			"userPayType": userPayType,
			"userType": userInfo.user_id ? '已注册' : '游客',
			"report_url": '/business-center-app-zjf/api/hotsLogs/logs-setting_subscribe'
		}
		return request('/buryingPoint', params)
	},



	// 数据查看记录
	dataLookLogs: async (param) => {
		var userInfo = store.state.userInfo
		var token = store.state.token

		// #ifdef APP
		var sourceType = 'APP'
		// #endif

		// #ifdef H5
		var sourceType = 'H5'
		// #endif

		var userPayType = '免费'
		if (userInfo.user_class > 0) {
			userPayType = '付费'
		}

		let params = {
			"biddingType": param.biddingType,
			"channelType": userInfo.channelType,
			"city": param.city,
			// "industryObjs": [{
			// 	"key": "",
			// 	"value": ""
			// }],
			"industryObjs": param.industryObjs,
			"openId": userInfo.open_id,
			"projectType": param.projectType,
			"province": param.province,
			"requestDate": getDataTime(),
			"requestIp": userInfo.user_ip_address || await getIP(),
			"sourceType": sourceType,
			"titleId": param.titleId,
			"titleName": param.titleName,
			"url": param.toUrl,
			"userId": userInfo.user_id || Date.parse(new Date())/1000,
			"userNickName": userInfo.user_name || userInfo.nick_name,
			"userPayType": userPayType,
			"userRegisterTime": getDataTime(userInfo.addtime),
			"userType": userInfo.user_id ? '已注册' : '游客',
			"report_url": '/business-center-app-zjf/api/dataLookLogs/logs'
		}
		return request('/buryingPoint', params)
	},



	// ------------------埋点方法  end-----------------------

}
